<!--
 Copyright (C) 2024 bAvenir

 This program and the accompanying materials are made
 available under the terms of the Eclipse Public License 2.0
 which is available at https://www.eclipse.org/legal/epl-2.0/

 SPDX-License-Identifier: EPL-2.0
-->

<app-connect-to-node-card *ngIf="initializing$ | async; else initilized" title="Data Broker detection" routeOnBack="/onboarding/connect-to-node">
  <div class="flex flex-col items-center">
    <div class="text-text-300 w-96">Running detection on the local address to find the Data Broker</div>
    <div class="mt-20">
      <app-spinner></app-spinner>
    </div>
  </div>
</app-connect-to-node-card>
<ng-template #initilized>
  <ng-container *ngIf="!(healthcheckError$ | async); else hasSslError">
    <ng-container *ngLet="broker$ | async as broker">
      <app-connect-to-node-card *ngIf="broker" title="Data Broker detected" routeOnBack="/onboarding/connect-to-node">
        <div class="flex flex-col items-center">
          <div class="text-text-300 w-96">A Data Broker was detected running on the local address</div>
          <div class="mt-10">
            <app-data-broker-card [broker]="broker"></app-data-broker-card>
            <div *ngIf="!isLoggedIn" class="mt-10 w-96">
              {{ broker.online ? 'To access the Broker, pelase login to platform' : 'To connect the Broker to platform, pelase login first' }}
            </div>
            <div *ngIf="isLoggedIn" class="mt-10 w-96">{{ broker.online ? 'The Broker is already connected to the platform' : 'Connect the Broker to the platform' }}</div>
          </div>
        </div>
        <div class="pb-20 mt-10 flex flex-col items-center gap-1">
          <app-connect-button></app-connect-button>
          <div class="flex flex-col divide-y divide-borderGrey">
            <p-button label="Connect to different Broker" [text]="true" severity="secondary" (onClick)="connectToDifferentBroker()"></p-button>
            <app-use-offline-button *ngIf="broker && !broker.online"></app-use-offline-button>
          </div>
        </div>
      </app-connect-to-node-card>
      <app-connect-to-node-card *ngIf="!broker" title="Custom Data Broker address" routeOnBack="/onboarding/connect-to-node">
        <app-custom-node-address></app-custom-node-address>
      </app-connect-to-node-card>
    </ng-container>
  </ng-container>
  <ng-template #hasSslError>
    <app-connect-to-node-card title="Failed to detect the Data Broker" routeOnBack="/onboarding/connect-to-node">
      <div class="flex flex-col items-center gap-10 mt-10">
        <app-ssl-error [address]="healthcheckError!"></app-ssl-error>
        <div class="flex flex-col items-center mt-10">
          <p-button label="Re-run detection" (click)="runDetection()" icon="pi pi-sync" [style]="{ width: '200px' }"></p-button>
        </div>
      </div>
    </app-connect-to-node-card>
  </ng-template>
</ng-template>
